# Copyright (c) 2000-2007, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

%define _with_repolib 1

# If you want repolib package to be built,
# issue the following: 'rpmbuild --with repolib'
%define with_repolib %{?_with_repolib:1}%{!?_with_repolib:0}
%define without_repolib %{!?_with_repolib:1}%{?_with_repolib:0}

%define repo    %{_javadir}/repository.jboss.com
%define repodir %{repo}/apache-xml-commons/1.3.03-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

%define _without_gcj_support 1

%define gcj_support %{?_with_gcj_support:1}%{!?_with_gcj_support:%{?_without_gcj_support:0}%{!?_without_gcj_support:%{?_gcj_support:%{_gcj_support}}%{!?_gcj_support:0}}}
%define section free
%define whichver 1.0

Summary:        Common code for XML projects
Name:           xml-commons
Version:        1.3.03
Release:        7jpp.ep1.3%{?dist}
Epoch:          0
License:        Apache Software License/W3C/Public Domain
URL:            http://xml.apache.org/commons/
Source0:        xml-commons-external-1.3.03-src.tar.gz
# svn export http://svn.apache.org/repos/asf/xml/commons/tags/xml-commons-external-1_3_03/java/external/

Source1:        xml-commons-1.0.b2.tar.gz
Source2:        xml-commons.which.script
Source3:        xml-commons-1.3.03-component-info.xml

BuildRequires:  ant, jpackage-utils >= 0:1.5
BuildRequires:  coreutils
Group:          Text Processing/Markup/XML
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-buildroot
%if ! %{gcj_support}
BuildArch:      noarch
%endif

%description
xml-commons is focused on common code and guidelines for xml projects.
It's first focus will be to organize and have common packaging for the
various externally-defined standards code relating to XML - things like
the DOM, SAX, and JAXP interfaces.
As the xml-commons community forms, we also hope to serve as a holding
area for other common xml-related utilities and code, and to help
promulgate common packaging, testing, documentation, and other
guidelines across all xml.apache.org subprojects.

%package jaxp-apis
Summary:        APIs subproject of %{name}
Group:          Text Processing/Markup/XML
Requires:       %{name} = %{epoch}:%{version}-%{release}
Provides:       jaxp = 1.3
Provides:       xml-commons-jaxp-1.3-apis = %{epoch}:%{version}-%{release}
Provides:       xml-commons-apis = %{epoch}:%{version}-%{release}

#Note: what is below is commented due to the version of rpm in RHEL 4
#      not support obsoleting files.
#Note: xml-commons-apis has been named to xml-commons-jaxp-apis due to
#      the JDK rpm proving xml-commons-apis. Without this name change
#      whenever this package would be updated on the system, the JDK rpm 
#      would be removed. Since the JDK rpm also unversioned the 
#      xml-commons-apis virtual provides, we need to do some tricky
#      obsoleting to make sure things will work properly.

# To obsolete xml-commons-apis 1.0
#Obsoletes:      %{_javadir}/xml-commons-apis-1.0.jar
# To obsolete xml-commons-apis 1.3.02
#Obsoletes:      %{_javadir}/xml-commons-apis-1.3.02.jar
# To obsolete xml-commons-jaxp-1.3-apis
#Obsoletes:      %{_javadir}/xml-commons-jaxp-1.3-apis-1.3.03.jar      

%if %{with_repolib}
BuildRequires: xml-commons-resolver12-repolib >= 1.2
%endif

%if %{gcj_support}
BuildRequires:          java-gcj-compat-devel
Requires(post):         java-gcj-compat
Requires(postun):       java-gcj-compat
%endif

%description jaxp-apis
APIs subproject of %{name}.

%package which
Summary:        Which subproject of %{name}
Group:          Text Processing/Markup/XML
Requires:       %{name} = %{epoch}:%{version}-%{release}
Requires:       jpackage-utils >= 0:1.5

%if %{gcj_support}
BuildRequires:          java-gcj-compat-devel
Requires(post):         java-gcj-compat
Requires(postun):       java-gcj-compat
%endif

%description which
Which subproject of %{name}.

%package jaxp-apis-manual
Summary:        Manual for %{name}-jaxp-api
Group:          Text Processing/Markup/XML
Requires:       %{name}-jaxp-apis-javadoc = %{epoch}:%{version}-%{release}

%if %{gcj_support}
BuildRequires:          java-gcj-compat-devel
Requires(post):         java-gcj-compat
Requires(postun):       java-gcj-compat
%endif

%description jaxp-apis-manual
Manual for %{name}-jaxp-apis.

%package jaxp-apis-javadoc
Summary:        Javadoc for %{name}-api
Group:          Development/Documentation
Requires(post): /bin/rm /bin/ln
Requires(postun): /bin/rm

%if %{gcj_support}
BuildRequires:          java-gcj-compat-devel
Requires(post):         java-gcj-compat
Requires(postun):       java-gcj-compat
%endif

%description jaxp-apis-javadoc
Javadoc for %{name}-jaxp-apis.

%package which-javadoc
Summary:        Javadoc for %{name}-which
Group:          Development/Documentation
Requires(post): /bin/rm /bin/ln
Requires(postun): /bin/rm

%if %{gcj_support}
BuildRequires:          java-gcj-compat-devel
Requires(post):         java-gcj-compat
Requires(postun):       java-gcj-compat
%endif

%description which-javadoc
Javadoc for %{name}-which.

%if %{with_repolib}
%package         repolib
Summary:         Artifacts to be uploaded to a repository library
Group:  Development/Libraries/Java

%description     repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio
%endif

# -----------------------------------------------------------------------------

%prep
%setup -q -c %{name}-%{version} 
tar xzf %{SOURCE1} 

tag=`echo %{name}-%{version}-%{release} | sed 's|\.|_|g'`
sed -i "s/@TAG@/$tag/g" %{SOURCE3}

# -----------------------------------------------------------------------------

%build
export OPT_JAR_LIST="./java/external/build/xml-apis.jar"
ant -f xml-commons-1_0_b2/java/which.xml 
ant -f external/build.xml jar javadoc

# -----------------------------------------------------------------------------

%install
rm -rf $RPM_BUILD_ROOT

# Jars
mkdir -p $RPM_BUILD_ROOT%{_javadir}
cp -p external/build/xml-apis.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}-apis-%{version}.jar
cp -p xml-commons-1_0_b2/java/build/which.jar \
  $RPM_BUILD_ROOT%{_javadir}/%{name}-which-%{version}.jar

# Jar versioning
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in %{name}-apis*.jar; do ln -sf ${jar} dom3-${jar}; done)
(cd $RPM_BUILD_ROOT%{_javadir} && for jar in *-%{version}.jar; do ln -sf ${jar} `echo $jar| sed "s|-%{version}||g"`; done)

ln -sf %{name}-apis.jar ${RPM_BUILD_ROOT}%{_javadir}/jaxp13.jar
ln -sf %{name}-apis.jar ${RPM_BUILD_ROOT}%{_javadir}/jaxp.jar
ln -sf %{name}-apis.jar ${RPM_BUILD_ROOT}%{_javadir}/xml-commons-jaxp-1.3-apis.jar

# Javadocs
mkdir -p $RPM_BUILD_ROOT%{_javadocdir}/%{name}-apis-%{version}
mkdir -p $RPM_BUILD_ROOT%{_javadocdir}/%{name}-which-%{version}
cp -pr external/build/docs/javadoc/* \
  $RPM_BUILD_ROOT%{_javadocdir}/%{name}-apis-%{version}
cp -pr xml-commons-1_0_b2/java/build/docs/javadocs/* \
  $RPM_BUILD_ROOT%{_javadocdir}/%{name}-which-%{version}

ln -s %{name}-apis-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name}-apis # ghost symlink
ln -s %{name}-which-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name}-which # ghost symlink

# Scripts
mkdir -p $RPM_BUILD_ROOT%{_bindir}
cp -p %{SOURCE2} $RPM_BUILD_ROOT%{_bindir}/xml-which

%if %{gcj_support}
%{_bindir}/aot-compile-rpm
%endif

%if %{with_repolib}
        install -d -m 755 $RPM_BUILD_ROOT%{repodir}
        install -d -m 755 $RPM_BUILD_ROOT%{repodirlib}
        install -m 755 %{SOURCE3} $RPM_BUILD_ROOT%{repodir}/component-info.xml
        install -d -m 755 $RPM_BUILD_ROOT%{repodirsrc}
        install -m 755 %{SOURCE0} $RPM_BUILD_ROOT%{repodirsrc}
        cp %{repo}/apache-xml-commons-resolver/1.2-brew/lib/resolver.jar $RPM_BUILD_ROOT%{repodirlib}
        cp %{repo}/apache-xml-commons-resolver/1.2-brew/src/* $RPM_BUILD_ROOT%{repodirsrc}
        cp $RPM_BUILD_ROOT%{_javadir}/xml-commons-apis.jar $RPM_BUILD_ROOT%{repodirlib}/xml-apis.jar
%endif

# -----------------------------------------------------------------------------

%clean
rm -rf $RPM_BUILD_ROOT

# -----------------------------------------------------------------------------

%if %{gcj_support}
%post jaxp-apis
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%postun jaxp-apis
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%post which
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%if %{gcj_support}
%postun which
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%files
%defattr(0644,root,root,0755)
%doc external/NOTICE external/LICENSE 

%files jaxp-apis
%defattr(0644,root,root,0755)
%{_javadir}/*apis*
%{_javadir}/jaxp13.jar
%{_javadir}/jaxp.jar
%{_javadir}/xml-commons-jaxp-1.3-apis.jar

%doc external/LICENSE external/NOTICE
%doc external/LICENSE.dom-documentation.txt external/README.dom.txt
%doc external/LICENSE.sax.txt external/README-sax  external/README.sax.txt

%if %{gcj_support}
%dir %attr(-,root,root) %{_libdir}/gcj/%{name}
%attr(-,root,root) %{_libdir}/gcj/%{name}/xml-commons-apis-1.3.03.jar.*
%endif

%files which
%defattr(0644,root,root,0755)
%{_javadir}/%{name}-which*
%attr(0755,root,root) %{_bindir}/*
%doc xml-commons-1_0_b2/LICENSE.txt

%if %{gcj_support}
%dir %attr(-,root,root) %{_libdir}/gcj/%{name}
%attr(-,root,root) %{_libdir}/gcj/%{name}/xml-commons-which-1.3.03.jar.*
%endif

%files jaxp-apis-manual
%defattr(0644,root,root,0755)
%doc external/build/docs/dom
%ghost %{_javadocdir}/%{name}-apis

%if %{gcj_support}
%dir %attr(-,root,root) %{_libdir}/gcj/%{name}
%attr(-,root,root) %{_libdir}/gcj/%{name}/xml-commons-which-1.3.03.jar.*
%endif

%files jaxp-apis-javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-apis-%{version}
%ghost %{_javadocdir}/%{name}-apis

%if %{gcj_support}
%dir %attr(-,root,root) %{_libdir}/gcj/%{name}
%attr(-,root,root) %{_libdir}/gcj/%{name}/xml-commons-which-1.3.03.jar.*
%endif

%files which-javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-which-%{version}
%ghost %{_javadocdir}/%{name}-which

%if %{gcj_support}
%dir %attr(-,root,root) %{_libdir}/gcj/%{name}
%attr(-,root,root) %{_libdir}/gcj/%{name}/xml-commons-which-1.3.03.jar.*
%endif


%if %{with_repolib}
%files repolib
%defattr(0644,root,root,0755)
%{repodir}
%endif

# -----------------------------------------------------------------------------

%post jaxp-apis-javadoc
rm -f %{_javadocdir}/%{name}-apis
ln -s %{name}-apis-%{version} %{_javadocdir}/%{name}-apis

%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%postun jaxp-apis-javadoc
if [ "$1" = "0" ]; then
  rm -f %{_javadocdir}/%{name}-apis
fi

%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%post which-javadoc
rm -f %{_javadocdir}/%{name}-which
ln -s %{name}-which-%{version} %{_javadocdir}/%{name}-which

%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

%postun which-javadoc
if [ "$1" = "0" ]; then
  rm -f %{_javadocdir}/%{name}-which
fi

# -----------------------------------------------------------------------------

%if %{gcj_support}
if [ -x %{_bindir}/rebuild-gcj-db ]
then
  %{_bindir}/rebuild-gcj-db
fi
%endif

#FIXME: this version requires that there are no xml-commons-apis packages
#       installed on the system. If an xml-commons-apis pacakge is installed
#       on the system the user will have to manually remove it themselves:
#       $ rpm -e --nodeps xml-commons-apis; rpm -U xml-commons-jaxp-apis

%changelog
* Fri Mar 30 2007 Matt Wringe <mwringe@redhat.com> - 0:1.3-03-7jpp.ep1.3
- Remove conflict on xml-commons-apis

* Thu Mar 15 2007 Matt Wringe <mwringe@redhat.com> - 0:1.3.03-7jpp.ep1.2
- Update to 1.3.03
- add conditional gcj support
- Add repolib option
- Note: the xml-commons-apis subpackage has been named xml-commons-jaxp-apis
  to allow updates without removing the jdk package which has a virtual 
  provides on xml-commons-apis.
- Note: this package's release says 1.3.03-7jpp, but this package is actually
  based on the 1.3.02-0.b2.7jpp release. The jpp number has been artifically
  raised to 7jpp since there is already a 1.3.03-7jpp package, and bumping the
  epoch is not desirable at this time.

* Mon Aug 21 2006 Fernando Nasser <fnasser@redhat.com> - 0:1.3.02-0.b2.7jpp.10
- Add missing Requires for post and postun javadoc sections

* Sat Jul 22 2006 Jakub Jelinek <jakub@redhat.com> - 0:1.3.02-0.b2.7jpp_9fc
- Rebuilt

* Wed Jul 12 2006 Jesse Keating <jkeating@redhat.com> - 0:1.3.02-0.b2.7jpp_8fc
- rebuild

* Mon Mar  6 2006 Jeremy Katz <katzj@redhat.com> - 0:1.3.02-0.b2.7jpp_7fc
- stop scriptlet spew

* Wed Feb 22 2006 Rafael Schloming <rafaels@redhat.com> - 0:1.3.02-0.b2.7jpp_6fc
- Updated to 1.3

* Fri Feb 10 2006 Jesse Keating <jkeating@redhat.com> - 0:1.0-0.b2.7jpp_5fc
- bump again for double-long bug on ppc(64)

* Wed Dec 21 2005 Jesse Keating <jkeating@redhat.com> 0:1.0-0.b2.7jpp_4fc
- rebuilt again

* Tue Dec 13 2005 Jesse Keating <jkeating@redhat.com>
- rebuilt for new gcj

* Fri Dec 09 2005 Jesse Keating <jkeating@redhat.com>
- rebuilt

* Fri Jul 15 2005 Gary Benson <gbenson@redhat.com> - 0:1.0-0.b2.7jpp_3fc
- Build on ia64, ppc64, s390 and s390x.
- Switch to aot-compile-rpm (also BC-compiles the which jar).

* Wed Jun 15 2005 Gary Benson <gbenson@redhat.com> - 0:1.0-0.b2.7jpp_2fc
- Remove all prebuilt stuff from the tarball.

* Thu May 26 2005 Gary Benson <gbenson@redhat.com> - 0:1.0-0.b2.7jpp_1fc
- Upgrade to 1.0-0.b2.7jpp.
- Remove now-unnecessary workaround for #130162.
- Rearrange how BC-compiled stuff is built and installed.

* Mon May 23 2005 Gary Benson <gbenson@redhat.com> - 0:1.0-0.b2.6jpp_13fc
- Add alpha to the list of build architectures (#157522).
- Use absolute paths for rebuild-gcj-db.

* Thu May  5 2005 Gary Benson <gbenson@redhat.com> - 0:1.0-0.b2.6jpp_12fc
- Add dependencies for %%post and %%postun scriptlets (#156901).

* Tue May  3 2005 Gary Benson <gbenson@redhat.com> - 0:1.0-0.b2.6jpp_11fc
- BC-compile the API jar.

* Tue Apr 26 2005 Gary Benson <gbenson@redhat.com> - 0:1.0-0.b2.6jpp_10fc
- Remove gcj endorsed dir support (#155693).

* Mon Apr 25 2005 Gary Benson <gbenson@redhat.com> - 0:1.0-0.b2.6jpp_9fc
- Provide a default transformer when running under libgcj.

* Mon Apr 25 2005 Gary Benson <gbenson@redhat.com> - 0:1.0-0.b2.6jpp_8fc
- Provide a default DOM builder when running under libgcj (#155693).

* Fri Apr 22 2005 Gary Benson <gbenson@redhat.com> - 0:1.0-0.b2.6jpp_7fc
- Provide a default SAX parser when running under libgcj (#155693).

* Thu Apr 21 2005 Gary Benson <gbenson@redhat.com> - 0:1.0-0.b2.6jpp_6fc
- Add gcj endorsed dir support.

* Tue Jan 11 2005 Gary Benson <gbenson@redhat.com> - 0:1.0-0.b2.6jpp_5fc
- Sync with RHAPS.

* Thu Nov  4 2004 Gary Benson <gbenson@redhat.com> - 0:1.0-0.b2.6jpp_4fc
- Build into Fedora.

* Thu Oct 28 2004 Gary Benson <gbenson@redhat.com> - 0:1.0-0.b2.6jpp_3fc
- Bootstrap into Fedora.

* Fri Oct 1 2004 Andrew Overholt <overholt@redhat.com> - 0:1.0-0.b2.6jpp_3rh
- add coreutils BuildRequires

* Thu Mar  4 2004 Frank Ch. Eigler <fche@redhat.com> - 0:1.0-0.b2.6jpp_2rh
- RH vacuuming part II

* Tue Mar  2 2004 Frank Ch. Eigler <fche@redhat.com> - 0:1.0-0.b2.6jpp_1rh
- RH vacuuming

* Thu Aug 26 2003 Ralph Apel <r.apel at r-apel.de> - 0:1.0-0.b2.7jpp
- Build with ant-1.6.2

* Mon May  5 2003 Ville Skyttä <ville.skytta at iki.fi> - 0:1.0-0.b2.6jpp
- Fix non-versioned javadoc symlinking.

* Mon Apr 21 2003 Ville Skyttä <ville.skytta at iki.fi> - 0:1.0-0.b2.5jpp
- Fix xml-which script.
- Include non-versioned javadoc symlinks.
- Add Epoch: 0.
- Fix jpackage-utils dependency versions.

* Thu Mar 13 2003 Nicolas Mailhot <Nicolas.Mailhot at jpackage.org> - 1.0-0.b2.4jpp
- For jpackage-utils 1.5

* Wed Nov 13 2002 Ville Skyttä <ville.skytta at iki.fi> - 1.0-0.b2.3jpp
- Following upstream changes, resolver is now built from its own package.

* Sun Nov  3 2002 Ville Skyttä <ville.skytta at iki.fi> 1.0-0.b2.2jpp
- Split resolver into its own subpackage.
- Fix Group, Vendor and Distribution tags.
- Use sed instead of bash 2 extension when symlinking jars.
- Add resolver and which shell scripts.

* Thu Jul 11 2002 Henri Gomez <hgomez@users.sourceforge.net> 1.0-0.b2.1jpp
- 1.0.b2
- get tarball from xml.apache.org
- add macro section

* Fri Jan 18 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 1.0-0.b1.1jpp
- first jpp release
